/*
 MIT LICENSE
 Copyright (c) 2007 Monsur Hossain (http://monsur.hossai.in)

 Permission is hereby granted, free of charge, to any person
 obtaining a copy of this software and associated documentation
 files (the "Software"), to deal in the Software without
 restriction, including without limitation the rights to use,
 copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the
 Software is furnished to do so, subject to the following
 conditions:

 The above copyright notice and this permission notice shall be
 included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 OTHER DEALINGS IN THE SOFTWARE.
 */
function Cache(e,t,n){this.maxSize_=e||-1;this.debug_=t||false;this.storage_=n||new Cache.BasicCacheStorage;this.fillFactor_=.75;this.stats_={};this.stats_["hits"]=0;this.stats_["misses"]=0;this.log_("Initialized cache with size "+e)}var CachePriority={LOW:1,NORMAL:2,HIGH:4};Cache.BasicCacheStorage=function(){this.items_={};this.count_=0};Cache.BasicCacheStorage.prototype.get=function(e){return this.items_[e]};Cache.BasicCacheStorage.prototype.set=function(e,t){if(typeof this.get(e)==="undefined")this.count_++;this.items_[e]=t};Cache.BasicCacheStorage.prototype.size=function(e,t){return this.count_};Cache.BasicCacheStorage.prototype.remove=function(e){var t=this.get(e);if(typeof t!=="undefined")this.count_--;delete this.items_[e];return t};Cache.BasicCacheStorage.prototype.keys=function(){var e=[],t;for(t in this.items_)e.push(t);return e};Cache.LocalStorageCacheStorage=function(e){this.prefix_="cache-storage."+(e||"default")+".";var t=this.prefix_.replace(/[-[\]{}()*+?.,\\^$|#\s]/g,"\\$&");this.regexp_=new RegExp("^"+t)};Cache.LocalStorageCacheStorage.prototype.get=function(e){var t=window.localStorage[this.prefix_+e];if(t)return JSON.parse(t);return null};Cache.LocalStorageCacheStorage.prototype.set=function(e,t){window.localStorage[this.prefix_+e]=JSON.stringify(t)};Cache.LocalStorageCacheStorage.prototype.size=function(e,t){return this.keys().length};Cache.LocalStorageCacheStorage.prototype.remove=function(e){var t=this.get(e);delete window.localStorage[this.prefix_+e];return t};Cache.LocalStorageCacheStorage.prototype.keys=function(){var e=[],t;for(t in window.localStorage){if(t.match(this.regexp_))e.push(t.replace(this.prefix_,""))}return e};Cache.prototype.getItem=function(e){var t=this.storage_.get(e);if(t!=null){if(!this.isExpired_(t)){t.lastAccessed=(new Date).getTime()}else{this.removeItem(e);t=null}}var n=t?t.value:null;if(n){this.stats_["hits"]++;this.log_("Cache HIT for key "+e)}else{this.stats_["misses"]++;this.log_("Cache MISS for key "+e)}return n};Cache._CacheItem=function(e,t,n){if(!e){throw new Error("key cannot be null or empty")}this.key=e;this.value=t;n=n||{};if(n.expirationAbsolute){n.expirationAbsolute=n.expirationAbsolute.getTime()}if(!n.priority){n.priority=CachePriority.NORMAL}this.options=n;this.lastAccessed=(new Date).getTime()};Cache.prototype.setItem=function(e,t,n){if(this.storage_.get(e)!=null){this.removeItem(e)}this.addItem_(new Cache._CacheItem(e,t,n));this.log_("Setting key "+e);if(this.maxSize_>0&&this.size()>this.maxSize_){var r=this;setTimeout(function(){r.purge_.call(r)},0)}};Cache.prototype.clear=function(){var e=this.storage_.keys();for(var t=0;t<e.length;t++){this.removeItem(e[t])}this.log_("Cache cleared")};Cache.prototype.getStats=function(){return this.stats_};Cache.prototype.toHtmlString=function(){var e=this.size()+" item(s) in cache<br /><ul>";var t=this.storage_.keys();for(var n=0;n<t.length;n++){var r=this.storage_.get(t[n]);e=e+"<li>"+r.key.toString()+" = "+r.value.toString()+"</li>"}e=e+"</ul>";return e};Cache.prototype.resize=function(e){this.log_("Resizing Cache from "+this.maxSize_+" to "+e);var t=this.maxSize_;this.maxSize_=e;if(e>0&&(t<0||e<t)){if(this.size()>e){this.purge_()}}this.log_("Resizing done")};Cache.prototype.purge_=function(){var e=new Array;var t=Math.round(this.maxSize_*this.fillFactor_);if(this.maxSize_<0)t=this.size()*this.fillFactor_;var n=this.storage_.keys();for(var r=0;r<n.length;r++){var i=n[r];var s=this.storage_.get(i);if(this.isExpired_(s)){this.removeItem(i)}else{e.push(s)}}if(e.length>t){e=e.sort(function(e,t){if(e.options.priority!=t.options.priority){return t.options.priority-e.options.priority}else{return t.lastAccessed-e.lastAccessed}});while(e.length>t){var o=e.pop();this.removeItem(o.key)}}this.log_("Purged cached")};Cache.prototype.addItem_=function(e,t){var n=this;try{this.storage_.set(e.key,e)}catch(r){if(t){this.log_("Failed setting again, giving up: "+r.toString());throw r}this.log_("Error adding item, purging and trying again: "+r.toString());this.purge_();this.addItem_(e,true)}};Cache.prototype.removeItem=function(e){var t=this.storage_.remove(e);this.log_("removed key "+e);if(t&&t.options&&t.options.callback){setTimeout(function(){t.options.callback.call(null,t.key,t.value)},0)}return t?t.value:null};Cache.prototype.size=function(){return this.storage_.size()};Cache.prototype.isExpired_=function(e){var t=(new Date).getTime();var n=false;if(e.options.expirationAbsolute&&e.options.expirationAbsolute<t){n=true}if(!n&&e.options.expirationSliding){var r=e.lastAccessed+e.options.expirationSliding*1e3;if(r<t){n=true}}return n};Cache.prototype.log_=function(e){if(this.debug_){console.log(e)}};if(typeof module!=="undefined"){module.exports=Cache}