﻿var SLStreetsideModule = function (map) {
    var _slMap,
        _ssPin,
        _ssTileLayer,
        _ssHostId,
        _options = {
            showBtn: true,
            pinOptions: {
                icon: 'images/StreetsideCursor.png',
                width: 20,
                height: 41,
                anchor: new Microsoft.Maps.Point(10, 40)
            }
        };

    /**************************** Constructor *******************************/

    (function () {
        //Set z-index of map
        var mapContainer = map.getRootElement();
        mapContainer.style.zIndex = 1;

        var mapParent = mapContainer.parentNode;

        //Load Silverlight control
        var loadedEvent = wrapCallback(function (sender, args) {
            var SLControl = sender.getHost();
            _slMap = SLControl.Content.SLMap;

            _slMap.SetHideMapMethod(wrapCallback(hideSS));
        });

        _ssHostId = mapParent.id + '_ssHost';

        var ssDiv = document.createElement("div");
        ssDiv.id = _ssHostId;
        ssDiv.style.position = 'absolute';
        ssDiv.style.top = '0px';
        ssDiv.style.left = '0px';
        ssDiv.style.zIndex = 0;
        ssDiv.innerHTML = '<object data="data:application/x-silverlight-2," type="application/x-silverlight-2" style="width:' + map.getWidth() + 'px;height:' + map.getHeight() + 'px;">' +
                '<param name="source" value="ClientBin/BMv7.SilverlightStreetsideModule.xap"/>' +
                '<param name="background" value="Transparent" />' +
                '<param name="minRuntimeVersion" value="2.0.31005.0" />' +
                '<param name="autoUpgrade" value="true" />' +
                '<param name="onLoad" value="' + loadedEvent + '" />' +
                '<param name="windowless" value="true"/>' +
                '<a href="http://go.microsoft.com/fwlink/?LinkID=149156&v=3.0.40624.0" style="text-decoration:none">' +
                    '<img src="http://go.microsoft.com/fwlink/?LinkId=108181" alt="Get Microsoft Silverlight" style="border-style:none"/>' +
                '</a>' +
            '</object><iframe id="_sl_historyFrame" style="visibility:hidden;height:0px;width:0px;border:0px"></iframe>';
        mapParent.appendChild(ssDiv);

        //Add streetside button
        var clickEvent = wrapCallback(enableSSOnJS);

        var btnDiv = document.createElement("div");
        btnDiv.id = mapParent.id + "_SSBtn";
        btnDiv.className = "streetsideBtn";
        btnDiv.innerHTML = "<a href='javascript:void(0);' onclick='" + clickEvent + "(true);' title='Streetside'></a>";
        mapParent.appendChild(btnDiv);

        //Create Streetside tile layer
        _ssTileLayer = new Microsoft.Maps.TileLayer({ mercator: new Microsoft.Maps.TileSource({ uriConstructor: 'http://ecn.t0.tiles.virtualearth.net/tiles/hcn{quadkey}?g=915&n=z' }), visible: false });
        map.entities.push(_ssTileLayer);
    })();

    /**************************** Private Methods *******************************/

    function enableSSOnJS(enable) {
        if (enable) {
            _ssTileLayer.setOptions({ visible: true });

            _ssPin = new Microsoft.Maps.Pushpin(new Microsoft.Maps.Location(0, 0), _options.pinOptions);
            map.entities.push(_ssPin);

            moveHandler = Microsoft.Maps.Events.addHandler(map, 'mousemove', function (e) {
                if (e.targetType == 'map') {
                    _ssPin.setLocation(e.target.tryPixelToLocation(new Microsoft.Maps.Point(e.getX(), e.getY())));
                }
            });

            clickHandler = Microsoft.Maps.Events.addHandler(map, 'click', function (e) {
                showSS(map.tryPixelToLocation(new Microsoft.Maps.Point(e.getX(), e.getY())));
            });
        } else {
            _ssTileLayer.setOptions({ visible: false });

            Microsoft.Maps.Events.removeHandler(moveHandler);
            Microsoft.Maps.Events.removeHandler(clickHandler);

            map.entities.remove(_ssPin);
        }
    }

    function hideSS() {
        document.getElementById(_ssHostId).style.zIndex = 0;
    }

    function showSS(loc) {
        _slMap.SetMapView(loc.latitude, loc.longitude);

        document.getElementById(_ssHostId).style.zIndex = 2;

        enableSSOnJS(false);
    }

    //Wraps a callback with a uniquely named global function.
    function wrapCallback(callback) {
        var rand = Math.floor(Math.random() * 100000);

        while (window['ss' + rand] != null) {
            rand = Math.floor(Math.random() * 100000);
        }

        var name = 'ss' + rand;
        window[name] = function (r) {
            callback(r);
        };

        return name;
    }

    /**************************** Public Methods *******************************/

    this.show = function () {
        showSS();
    };

    this.hide = function () {
        hideSS();
    };
};

Microsoft.Maps.moduleLoaded('SLStreetsideModule');